#ifndef COORDINATE_H
#define COORDINATE_H
#include "param.h"

typedef struct {
    double x, y, z;
} dvec3_t;
typedef struct {
    int x, y, z;
} ivec3_t;
typedef struct {
    int x, y;
} ivec2_t;

typedef ivec3_t pos3_t;
typedef ivec3_t velo3_t;
typedef ivec3_t acc3_t;
typedef ivec3_t size3_t;

typedef ivec2_t pos2_t;


typedef struct {
    pos3_t st;
    pos3_t en;
} region3_t;

#define Deg2Rad(d) ((d)*PI/180)

#define IsDelta(x) ((x) > -DELTA && (x) < DELTA)

#define Vec3Size2(pos3) \
    ((pos3).x*(pos3).x + (pos3).y*(pos3).y + (pos3).z*(pos3).z)
#define Vec3Size(pos3) \
    (sqrt((pos3).x*(pos3).x + (pos3).y*(pos3).y + (pos3).z*(pos3).z))

#define Size2ScreenSize(size, rz) \
    ((int)((size)*SIZE_COEF/(1+((double)(rz)*SPACE_ZSIZE*RESIZE_COEF/SCREEN_RZMAX)/SPACE_ZSIZE)))
#define Rx2ScreenX(rx, rz) \
    ((int)(SCREEN_W * (rx) / (SCREEN_DEPTH + (rz)) + SCREEN_OX))
#define Ry2ScreenY(ry, rz) \
    ((int)(SCREEN_W * (ry+SCREEN_YOFFSET) / (SCREEN_DEPTH + (rz)) + SCREEN_OY))

typedef enum {
    di_f=0, di_b=1
} dir_t;


//    (SCREEN_W * (ry+SCREEN_W*4) / (SCREEN_DEPTH + (rz)) + SCREEN_OY)
//#define AddVectorLimited(

#endif
