#include <stdio.h>
#include <stdlib.h>
#include <EzGraph.h>
#include "config.h"
#include "param.h"
#include "obj.h"
#include "enemybullet.h"

int hit_enemybullet(obj_t *obj, obj_t *enemybullet);

void setup_enemybullet(obj_t *obj){
    obj->velo3.x = obj->velo3.y = obj->velo3.z = 0;
    obj->enemybullet.lifespan = ENEMYBULLET_LIFESPAN;
    obj->enemybullet.damage = ENEMYBULLET_DAMAGE;
}

void set_dir_enemybullet(obj_t *obj, dir_t dir){
    assert(obj != NULL);
    obj->velo3.z = dir == di_f ? ENEMYBULLET_VELO : -ENEMYBULLET_VELO;
}
void set_destroyer_enemybullet(obj_t *obj, velo3_t velo3){
    obj->velo3 = velo3;
    obj->enemybullet.lifespan = DESTROYER_BULLET_LIFESPAN;
    obj->enemybullet.damage = DESTROYER_BULLET_DAMAGE;
}



void act_enemybullet(obj_t *obj){
    //    printf("mybullet act %d\n", (int)obj->pos3.z);
    obj->enemybullet.lifespan --;
    if (obj->enemybullet.lifespan <= 0){
        obj->valid = 0;
        //        free_obj(obj);
    }

    move_obj(obj);
    //    obj->pos3.z += obj->velo3.z;

    apply_hit_obj(obj, hit_enemybullet);
}

int hit_enemybullet(obj_t *obj, obj_t *enemybullet){
    if (obj->type == ot_enemybullet) return 0;
    if (obj->type == ot_drone) return 0;
    if (IsExploding(obj)) return 0;
    //    if (obj->type == ot_myrobo) return 0;

    if (is_obj_hit(obj, enemybullet)){
        damage_obj(obj, enemybullet->enemybullet.damage);
        enemybullet->valid = 0;
        //        free_obj(enemybullet);
        return 1;
    }
    return 0;
}
