#ifndef EVENT_H
#define EVENT_H
#include "config.h"
#include "obj_struct.h"
#include "coordinate.h"

typedef enum {
    et_invalid,
    et_begin,
    et_start = et_begin,     // ߥå󳫻

    et_complete,   // ߥåλ
    et_fail,      // ߥå(ưʳ)
    et_die,        // 
    et_in,          // ꥨꥢä
    et_out,         // ꥨꥢФ
    et_time,        // ˤʤä
    et_end,
} event_trigger_type_t;

typedef enum {
    eo_invalid,
    eo_begin,
    eo_create = eo_begin,          // ֥Ȥ
    eo_create_region,   // ֥ȷ֤ΰ
    eo_delete,   // ֥Ȥ(֤ñ˽)
    eo_destroy,  // ֥Ȥ˲(᡼ˤ˲Ʊ)
    eo_end,
} event_op_type_t;

typedef int event_id_t;
#define INVALID_EVENT_ID (-1)

void event_init(void);
void reset_event_list(void);
event_trigger_type_t event_trigger_name2type(char *str);
event_op_type_t event_op_name2type(char *str);
event_id_t enqueue_event_create(event_trigger_type_t et,
                                obj_type_t obj_type, pos3_t pos3);
event_id_t enqueue_event_create_region(event_trigger_type_t et,
                                       obj_type_t obj_type, region3_t region3,
                                       int num);
void register_events(void);
#ifdef DUMMY
// event¤ΤȤevent.c˸ʤ
typedef struct event_s *Event_t;
typedef struct event_list_s *EventList_t;

EventList_t create_event_list(void);
Event_t create_event(EventList_t event_list);
void set_event_create(Event_t event, obj_type_t obj_type, pos3_t pos3);
void set_event_create_region(Event_t event, obj_type_t obj_type, 
                             region3_t region3, int num);
#endif

#endif

