#ifndef EVENT_IN_H
#define EVENT_IN_H
#include "config.h"
#include "event.h"
#include "coordinate.h"
#include "obj_struct.h"

typedef struct {
    pos3_t pos3;
} event_param_pos;
typedef struct {
    region3_t region3;
} event_param_region;
typedef struct {
    int dummy;
} event_param_dummy;

typedef event_param_dummy event_param_start;
typedef struct {
    obj_type_t obj_type;
    pos3_t pos3;
} event_param_create;
typedef struct {
    obj_type_t obj_type;
    region3_t region3;
    int num;
} event_param_create_region;

typedef struct {
    event_trigger_type_t type;
    union {
        event_param_dummy started;
    } param;
} event_trigger_t;

typedef struct {
    event_op_type_t type;
    union {
        event_param_create create;
        event_param_create_region create_region;
    } param;
} event_op_t;

typedef struct event_s {
    event_trigger_t trigger;
    event_op_t op;
} event_t;

typedef struct event_list_s {
    int num;
    event_t events[MISSION_EVENT_NUM_MAX];
} event_list_t;

#endif

