#include <stdio.h>
#include <EzGraph.h>
#include "config.h"
#include "game.h"
#include "draw.h"
#include "obj_draw.h"
#include "obj.h"
#include "mission.h"
#include "main_state.h"
#include "rnd.h"

static int is_paused = 0;
static int is_x_down=0, is_z_down=0;
static int is_slow = 0;

void game_timerh(void);
void game_keyh(int key);
void game_key_releaseh(int key);
void check_keys(void);

void game_init(void){
}

void setup_game(void){
    obj_reset();

    EzSetTimerHandler(game_timerh, GAME_SPEED);

    EzSetKeyHandler(game_keyh);
    EzSetKeyReleaseHandler(game_key_releaseh);
    is_x_down = is_z_down = 0;

    setup_mission();
    // rposΤᡢ1ƤǤ
    update_objs();
}

// 'q'ǽλʤ褦ΥϥɥĤäƤ
void game_keyh(int key){
}

void game_key_releaseh(int key){
    //    printf("key :%d\n", key);
    switch (key){
        /*
    case 'z':
        myrobo_toggle_thrust_backward();
        break;
    case 'x':
        myrobo_toggle_thrust_forward();
        break;
        */
    case 'p':
        is_paused = !is_paused;
        if (is_paused){
            EzSetTimerHandler(NULL, 0);
        }
        else {
            EzSetTimerHandler(game_timerh, GAME_SPEED);
        }
        break;
    case 'q':
        set_main_state(ms_mission_select);
        break;
#ifdef DEBUG
    case 's':
        if (is_slow){
            EzSetTimerHandler(game_timerh, GAME_SPEED);
            is_slow = 0;
        }
        else {
            EzSetTimerHandler(game_timerh, GAME_SPEED*16);
            is_slow = 1;
        }
        break;
    case 'd':
        damage_myrobo(10);
        break;
    case 'w':
        is_wsensor_enabled() ? disable_wsensor() : enable_wsensor();
        break;
#endif        
    default:
        break;
    }
}

void game_timerh(void){

    if (is_myrobo_alive()) check_keys();
    //    move_myrobo();
    act_objs();
    update_objs();
    draw();
    // actdelete_objȺ줿֥Ȥzbuf˻ĤäƤ
    // ΤǡޤȤƤǺ
    delete_invalid_objs();
	}

void check_keys(void){
    char keys[32];
    EzQueryKeymap(keys);

    
    if (EzIsKeyPress(keys, EZ_Left)){
        if (EzIsKeyPress(keys, EZ_Shift_L) || EzIsKeyPress(keys, EZ_Shift_R)){
            myrobo_start_turn_left();
        }
        else {
            myrobo_thrust_left();
        }
    }
    else if (EzIsKeyPress(keys, EZ_Right)){
        if (EzIsKeyPress(keys, EZ_Shift_L) || EzIsKeyPress(keys, EZ_Shift_R)){
            myrobo_start_turn_right();
        }
        else {
            myrobo_thrust_right();
        }
    }
    else {
        myrobo_halt_x();
    }

    if (EzIsKeyPress(keys, EZ_Up)){
        myrobo_thrust_up();
    }
    else if (EzIsKeyPress(keys, EZ_Down)){
        myrobo_thrust_down();
    }
    else {
        myrobo_halt_y();
    }

    if (EzIsKeyPress(keys, EZ_Z)){
        if (is_z_down == 0){
            myrobo_toggle_thrust_backward();
            is_z_down = 1;
        }
    }
    else {
        is_z_down = 0;
    }
    if (EzIsKeyPress(keys, EZ_X)){
        if (is_x_down == 0){
            myrobo_toggle_thrust_forward();
            is_x_down = 1;
        }
    }
    else {
        is_x_down = 0;
    }

    if (EzIsKeyPress(keys, EZ_Control_L)){
        myrobo_set_firing();
    }

}

