#include "stdio.h"
#include "EzGraph.h"
#include "config.h"
#include "graphic.h"
#include "process_xpm.h"

#include "xpm/chee_init.xpm"
#include "xpm/chee_back.xpm"

typedef struct {
    graphic_id_t gid;
    char **xpm;
} xpm_resource_t;

#define XR(name) {gi_ ## name, name ## _xpm}

static xpm_resource_t xpm_resources[] = {
    XR(chee),
    XR(chee_back),
};
#define XPM_RESOURCE_NUM (sizeof(xpm_resources)/sizeof(xpm_resource_t))

static EzImage imgs[gi_end];


int graphic_init(void){
    int i;
    dynamic_xpm_t *src_dxpm, *dest_dxpm;
    char **xpm_buf;

    for (i = 0 ; i < XPM_RESOURCE_NUM ; i++){
        //        magnify_xpm(xpm_resources[i].xpm, xpm_buf);
        imgs[xpm_resources[i].gid] = EzReadXPM(xpm_resources[i].xpm);
    }

    src_dxpm = alloc_dynamic_xpm(32, 32);
    dest_dxpm = alloc_dynamic_xpm(64, 64);
    xpm_buf = alloc_xpm_buffer(256, 256, 9);
    xpm2dynamic_xpm(chee_back_xpm, src_dxpm);
    //    show_dynamic_xpm(src_dxpm);
    magnify_xpm(2, 2, src_dxpm, dest_dxpm);
    dynamic_xpm2xpm(dest_dxpm, xpm_buf);
    imgs[gi_chee_back] = EzReadXPM(xpm_buf);
    free_xpm_buffer(xpm_buf);
    return 0;


    /*
    //    static char xpm_buf[1+9+256][256+1];
    static dynamic_xpm_t *src_dxpm, dest_dxpm;

    dxpm_src = alloc_dynamic_xpm(32, 32);
    dxpm_dest = alloc_dynamic_xpm(256, 256);
    xpm2dynamic_xpm(chee_xpm, src_dxpm);
    show_dynamic_xpm(src_dxpm);
    magnify_dynamic_xpm(des_dxpm, src_dxpm, 
    show_dynamic_xpm(dxpm_dest);
    */
}



/*
int magnify_xpm(char *src[], char *dest[]){
    int six=0, dix = 0;
    int width, height, cnum, depth;
    if (sscanf(src[0], "%d %d %d %d", &width, &height, &cnum, &depth) != 4){
        return 1;
    }
    sprintf(dest[0], "%d %d %d %d", width, height, cnum, depth);
    printf("%d|%s|\n", 0, dest[0]);

    return 0;
}
*/
