#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <EzGraph.h>
#include "config.h"
#include "layout.h"
#include "param.h"
#include "main_state.h"
#include "title.h"
#include "game.h"
#include "obj.h"
#include "event.h"
#include "mission.h"
#include "mission_select.h"
#include "briefing.h"
#include "draw.h"
#include "rnd.h"
#include "getarg.h"
#include "file.h"

void init(int argc, char *argv[]);
void quit(void);



unsigned char major_version = MAJOR_VERSION;
unsigned char minor_version = MINOR_VERSION;


int main(int argc, char *argv[]){

    EzOpenWindow(WIN_WIDTH, WIN_HEIGHT);
    init(argc, argv);

    set_main_state(ms_title);
    //    set_main_state(ms_game);

    EzEventLoop();
    quit();
    return 0;
}

// åǽλʤ褦ΥϥɥĤäƤ
void dummy_mouseh(int x, int y, unsigned int n){
}



void init(int argc, char *argv[]){

    if (getarg(argc, argv) != 0){
        exit(1);
    }
    file_init(argv[0], get_opt_str("savedir"), SAVE_DIR, LOG_FILE);

    EzSetMouseHandler(dummy_mouseh);
    EzSetFontSize(FONTSIZE);

    obj_init();
    event_init();
    mission_init(argv[0]);
    draw_init();
    title_init();
    mission_select_init();
    briefing_init();
    game_init();
    // ʤɤֽꤷΤǡ
    srnd((unsigned int)time(NULL));
}
void quit(void){
    puts("bye.");
}






