#ifndef MISSION_H
#define MISSION_H
#include "config.h"
#include "coordinate.h"
#include "event.h"
#include "obj_struct.h"
#include "jstr.h"

typedef struct {
    char title[JBufSize(MISSION_TITLE_LEN_MAX)];
    char briefing[BRIEFING_NUM_MAX][JBufSize(BRIEFING_LINE_LEN_MAX)];
    int briefing_num;
} mission_t;


void mission_init(char *argv0);
int get_mission_num(void);
char *get_mission_name(int no);
char *get_mission_title(int no);
void set_current_mission_no(int no);
int get_current_mission_no(void);
char *get_current_mission_title(void);
char *get_current_mission_briefing(int line_no);
int get_current_mission_briefing_num(void);
int load_mission_titles(void);
int load_mission(void);
void setup_mission(void);

#ifdef DUMMY
mission_id_t create_mission(char *name);
Event_t create_event_create(obj_type_t obj_type, pos3_t pos3);
Event_t create_event_create_region(obj_type_t obj_type, region3_t region3,
                                   int num);
void setup_mission(mission_id_t mid);

int load_mission(char *mission_name);
int load_current_mission(void);
void set_current_mission_name(char *name);
void register_events(void);
#endif

#endif
