#include <stdio.h>
#include <EzGraph.h>
#include "config.h"
#include "mission_select.h"
#include "mission_select_draw.h"
#include "mission.h"
#include "main_state.h"

static int cursor_pos;
static int mission_num;

void mission_select_keyh(int key);
void mission_select_key_releaseh(int key);
void mission_select_timerh(void);

void mission_select_init(void){
    cursor_pos = 0;
    load_mission_titles();
    mission_num = get_mission_num();
}



void setup_mission_select(void){
    EzSetKeyHandler(mission_select_keyh);
    EzSetKeyReleaseHandler(mission_select_key_releaseh);
    EzSetTimerHandler(mission_select_timerh, GAME_SPEED);
}

void mission_select_keyh(int key){
    switch (key){
    case EZ_Left:
    case EZ_Up:
        cursor_pos = (cursor_pos + mission_num - 1) % mission_num;
        break;
    case EZ_Right:
    case EZ_Down:
        cursor_pos = (cursor_pos + 1) % mission_num;
        break;
    default:
        break;
    }
}

void mission_select_key_releaseh(int key){
    switch (key){
    case ' ':
    case 13:
    case 'x':
        set_current_mission_no(cursor_pos);
        // briefingɬפʤΤǡǥɤƤ
        load_mission();
        set_main_state(ms_briefing);
        break;
    case 27:
    case 'q':
        set_main_state(ms_title);
        break;
    default:
        break;
    }
}

void mission_select_timerh(void){
    draw_mission_select(mission_num, cursor_pos);
}

