#include <stdio.h>
#include <EzGraph.h>
#include "config.h"
#include "layout.h"
#include "mission.h"
#include "mission_select_draw.h"

#define MENU_ITEM_LEN (MENU_FONTSIZE*(MISSION_TITLE_LEN_MAX+12)/2)

#define MenuItemLTY(ix) (ix*24+MISSION_SELECT_MENU_LTY)
#define MenuItemLTX ((WIN_WIDTH-MENU_ITEM_LEN)/2)
#define MenuItemRBX ((WIN_WIDTH+MENU_ITEM_LEN)/2)
#define MenuItemRBY(ix) (MenuItemLTY(ix)+MENU_FONTSIZE)


void draw_mission_select(int mission_num, int cursor_pos){
    int i;
    char buf[128];
    EzSetColorByRGB(255, 255, 255);
    for (i = 0 ; i < mission_num ; i++){
        sprintf(buf, "MISSION %2d", i+1);
        EzDrawStringB(MenuItemLTX, MenuItemRBY(i), buf);
        EzDrawStringB(MenuItemLTX+MENU_FONTSIZE*12/2, MenuItemRBY(i),
                      get_mission_title(i));
        //        EzDrawStringB(0, i*20+100, "hoge");
    }
    EzDrawBoxB(MenuItemLTX-4, MenuItemLTY(cursor_pos)-2,
               MenuItemRBX+4, MenuItemRBY(cursor_pos)+2);
    EzShowBuffer();
}
