#include <stdio.h>
#include <stdlib.h>
#include <EzGraph.h>
#include "config.h"
#include "param.h"
#include "obj.h"
#include "mybullet.h"

int hit_mybullet(obj_t *obj, obj_t *mybullet);

void setup_mybullet(obj_t *obj){
    obj->mybullet.lifespan = MYBULLET_LIFESPAN;
}

void set_dir_mybullet(obj_t *obj, dir_t dir){
    assert(obj != NULL);
    obj->velo3.x = obj->velo3.y = 0;
    obj->velo3.z = dir == di_f ? MYBULLET_VELO : -MYBULLET_VELO;
}

void act_mybullet(obj_t *obj){
    //    printf("mybullet act %d (%d, %d, %d)\n", (int)obj->pos3.z, obj->velo3.x, obj->velo3.y, obj->velo3.z);
    obj->mybullet.lifespan --;
    if (obj->mybullet.lifespan <= 0){
        obj->valid = 0;
    }

    move_obj(obj);
    //    obj->pos3.z += obj->velo3.z;

    apply_hit_obj(obj, hit_mybullet);
}

int hit_mybullet(obj_t *obj, obj_t *mybullet){
    switch (obj->type){
    case ot_myrobo:
    case ot_mybullet:
    case ot_goal:
        return 0;
    default:
        if (IsExploding(obj)) return 0;
        if (is_obj_hit(obj, mybullet)){
            damage_obj(obj, MYBULLET_DAMAGE);
            mybullet->valid = 0;
            return 1;
        }
        break;
    }
    return 0;
}
