#ifndef MYROBO_H
#define MYROBO_H
#include "config.h"
#include "myrobo_struct.h"

void myrobo_init(void);
void setup_myrobo(obj_t *obj);

void get_myrobo_pos3(pos3_t *pos3);

void myrobo_thrust_left(void);
void myrobo_thrust_right(void);
void myrobo_thrust_up(void);
void myrobo_thrust_down(void);
void myrobo_thrust_forward(void);
void myrobo_thrust_backward(void);
void myrobo_toggle_thrust_forward(void);
void myrobo_toggle_thrust_backward(void);


void myrobo_halt_x(void);
void myrobo_halt_y(void);
void myrobo_halt_z(void);
void myrobo_set_firing(void);
void myrobo_fire(void);

void act_myrobo(obj_t *obj);
void move_myrobo(void);

void myrobo_start_turn_left(void);
void myrobo_start_turn_right(void);
void myrobo_turn_left(void);
void myrobo_turn_right(void);
void myrobo_toggle_dir(void);
dir_t get_myrobo_dir(void);
int get_myrobo_hp(void);
int get_myrobo_turn_count(void);
int get_myrobo_die_count(void);
void inc_myrobo_die_count(void);


double get_myrobo_velo_z(void);
void damage_myrobo(int damage);
int hit_myrobo(obj_t *obj, obj_t *myrobo);
int is_myrobo_alive(void);
#endif
