#ifndef OBJ_H
#define OBJ_H
#include "config.h"
#include "coordinate.h"
#include "obj_struct.h"
#include "myrobo.h"
#include "dummy_target.h"
#include "enemy_destroyer.h"
#include "drone.h"
#include "mybullet.h"
#include "enemybullet.h"
#include "asteroid.h"
#include "mine.h"
#include "fragment.h"
#include "goal.h"

#define IsExploding(obj) ((obj)->explosion_count > 0)

        

int obj_init(void);
obj_type_t obj_name2type(char *str);
void obj_reset(void);
void push_obj_uni(obj_t **list, obj_t *obj);
obj_t *pop_obj_uni(obj_t **list);
void push_obj_bi(obj_t **list, obj_t *obj);
obj_t *pop_obj_bi(obj_t **list);
void delete_obj_bi(obj_t **list, obj_t *obj);
obj_t *alloc_obj(void);
void free_obj(obj_t *obj);
void for_each_obj(obj_callback_func_t func);
int for_each_obj_zbuf(obj_callback_func_t func, int zst, int zen);
int for_each_obj_zbuf2(obj_callback_func2_t func, int zst, int zen,
                       obj_t *base_obj);
void reset_obj_zbuf(void);
obj_t *create_obj(obj_type_t type, pos3_t pos3);
obj_t *create_obj_region(obj_type_t type, region3_t region3, int num);
void act_objs(void);
int act_obj(obj_t *obj);
void delete_invalid_objs(void);
int delete_invalid_obj(obj_t *obj);
void update_objs(void);
int get_obj_size(obj_type_t type);
void move_obj(obj_t *obj);
int is_obj_hit(obj_t *obj1, obj_t *obj2);
int is_obj_hit_myrobo(obj_t *obj);
void apply_hit_obj(obj_t *obj, obj_callback_func2_t func);
void damage_obj(obj_t *obj, int damage);

#ifdef DEBUG
void print_obj_list(obj_t *list);
void print_obj(obj_t *obj);
void print_alive_list(void);
void print_free_list(void);
#endif

#endif

