#ifndef OBJ_DRAW_H
#define OBJ_DRAW_H
#include "config.h"

#define ClipMapX(x) \
    ((int)(((x) < 0) ? 0 : (((x)>=SPACE_XSIZE) ? SPACE_XSIZE-1 : (x))))
#define ClipMapZ(z) \
    ((int)(((z) < 0) ? 0 : (((z)>=SPACE_ZSIZE) ? SPACE_ZSIZE-1 : (z))))

#define X2MapX(x) (ClipMapX(x) * MAP_XSIZE / SPACE_XSIZE + MAP_LTX)
#define Z2MapY(z) (MAP_RBY - ClipMapZ(z) * MAP_YSIZE / SPACE_ZSIZE)
#define Size2MapSize(s) ((s) * MAP_YSIZE / SPACE_ZSIZE)


void obj_draw_init(void);
void toggle_screen_dir(void);
void draw_screen_objs(void);
int draw_screen_obj(obj_t *obj);
void draw_map_objs(void);
int draw_map_obj(obj_t *obj);
void draw_radar_objs(void);
int draw_radar_f_obj(obj_t *obj);
int draw_radar_b_obj(obj_t *obj);
void draw_radar_obj(obj_t *obj, int rx, int ry);

#ifdef DEBUG
void draw_wsensor_objs(void);
int draw_wsensor_obj(obj_t *obj);
#endif

#endif
