#ifndef OBJ_STRUCT_H
#define OBJ_STRUCT_H
#include "coordinate.h"
#include "sprite.h"
#include "myrobo_struct.h"
#include "mybullet_struct.h"
#include "enemy_destroyer_struct.h"
#include "drone_struct.h"
#include "goal_struct.h"
#include "enemybullet_struct.h"
#include "asteroid_struct.h"
//#include "fragment_struct.h"


/*
  obj_t
  obj_tmyroboʤɤθͭե(myrobo_tʤ)
  ΤȤƼिmyrobo_t򻲾Ȥ뤬
  δؿץȥפobj_tʤɤɬפǤꡢ
  Υإåե뤬¸롣
  Τᡢ¤Τxx_struct.hȤʬΥ
*/

typedef enum {
    ot_invalid = 0,
    ot_begin,
    ot_asteroid = ot_begin,
    ot_myrobo,
    ot_mybullet,
    ot_dummy_target,
    ot_enemy_destroyer,
    ot_drone,
    ot_enemybullet,
    ot_goal,
    ot_mine,
    ot_fragment,

    ot_end,
} obj_type_t;

typedef struct obj_s {
    obj_type_t type;
    sprite_id_t sid;
    int size;
    int hp;
    int valid; // HP==0ǤȯϻĤᡢΥե饰0ˤʤä
    int explosion_count;
    pos3_t prev_pos3; // ե졼Ǥpos3
    pos3_t pos3; // кɸ
    pos3_t rpos3; // myroboФкɸ
    velo3_t velo3;
    acc3_t acc3;
    struct obj_s *prev;
    struct obj_s *next;
#ifdef DEBUG
    int id;
#endif
    union {
        obj_myrobo_t myrobo;
        obj_mybullet_t mybullet;
        obj_enemy_destroyer_t enemy_destroyer;
        obj_drone_t drone;
        obj_enemybullet_t enemybullet;
        obj_goal_t goal;
        obj_asteroid_t asteroid;
    };
} obj_t;

typedef int(*obj_callback_func_t)(obj_t *obj);
typedef int(*obj_callback_func2_t)(obj_t *obj1, obj_t *obj2);

typedef struct {
    void (*setup)(obj_t *obj);
    void (*act)(obj_t *obj);
} obj_callbacks_t;

typedef struct {
    int size;
    size3_t hitbox;
    int hp_max;
    sprite_id_t sid;
    obj_callbacks_t callbacks;
} obj_table_entry_t;

typedef struct {
    obj_type_t type;
    char *name;
    obj_table_entry_t entry;
} obj_info_t;


#endif
