#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <EzGraph.h>
#include "config.h"
#include "main_state.h"
#include "title.h"
#include "title_draw.h"

static title_menuitem_t cursor_pos;

void title_keyh(int key);
void title_key_releaseh(int key);
void title_timerh(void);

void title_init(void){
    cursor_pos = ti_game;
    title_draw_init();
}

void setup_title(void){
    EzSetKeyHandler(title_keyh);
    EzSetKeyReleaseHandler(title_key_releaseh);
    EzSetTimerHandler(title_timerh, GAME_SPEED);
}

void title_keyh(int key){
    switch (key){
    case EZ_Left:
    case EZ_Up:
        cursor_pos = (cursor_pos + ti_end - 1) % ti_end;
        break;
    case EZ_Right:
    case EZ_Down:
        cursor_pos = (cursor_pos + 1) % ti_end;
        break;
    default:
        break;
    }
}

void title_key_releaseh(int key){
    switch (key){
    case ' ':
    case 13:
    case 'x':
        switch (cursor_pos){
        case ti_game:
            set_main_state(ms_mission_select);
            break;
        case ti_config:
            puts("config");
            break;
        case ti_quit:
            set_main_state(ms_quit);
            break;
        default:
            assert(0);
            exit(1);
        }
        break;
    case 'q':
        set_main_state(ms_quit);
        break;
    default:
        break;
    }
}

void title_timerh(void){
    draw_title(cursor_pos);
}

