#include <stdio.h>
#include <string.h>
#include <EzGraph.h>
#include "config.h"
#include "layout.h"
#include "title.h"
#include "title_draw.h"
#include "sprite.h"
#include "coordinate.h"
#include "xpm/title.xpm"

static char *menu_item_strs[ti_end] = {
    "",
    "",
    "λ",
};

static EzImage title_img;


#define MENU_ITEM_LEN (MENU_FONTSIZE*2)

#define MenuItemLTY(ix) (ix*24+TITLE_MENU_LTY)
#define MenuItemLTX ((WIN_WIDTH-MENU_ITEM_LEN)/2)
#define MenuItemRBX ((WIN_WIDTH+MENU_ITEM_LEN)/2)
#define MenuItemRBY(ix) (MenuItemLTY(ix)+MENU_FONTSIZE)

void title_draw_init(void){
    title_img = EzReadXPM(title_xpm);
}

void draw_title(int cursor_pos){
    int i;

    EzPutB((WIN_WIDTH-TITLE_LOGO_WIDTH)/2, 60, title_img);
    /*
    EzSetColorByRGB(255, 255, 255);
    EzSetFontSize(64);
    EzDrawStringB(100, 100, "SPACE");
    EzDrawStringB(100-32, 140, "WARRIOR");
    */
    //    draw_sprite(500, 200, 96, 0, si_myrobo_turn_l9);
    //    draw_sprite(500, 300, 96, 1, si_myrobo_turn_l9);
    draw_sprite(470, 320, 139, di_b, si_dummy_target);
    draw_sprite(540, 260, 96, di_b, si_myrobo_title);
    draw_sprite(100, 300, 139, di_b, si_asteroid);
    draw_sprite(160, 340, 128, di_b, si_drone_01);
    //    draw_sprite(50, 400, 128, di_f, si_enemy_destroyer);
    //    draw_sprite(50, 400, 96, di_b, si_enemy_destroyer);
    //    draw_sprite(50, 440, 152, di_b, si_enemy_destroyer);
    //    draw_sprite(50, 440, 160, di_b, si_enemy_destroyer);
    //  draw_sprite(320, 440, 160, di_b, si_enemy_destroyer);
    
    EzSetFontSize(16);
    EzSetColorByRGB(255, 255, 255);
    for (i = 0 ; i < ti_end ; i++){
        // @todo ׼ʲif֥å
        if (i == ti_config){
            EzSetColorByRGB(120, 120, 120);
            EzDrawStringB(MenuItemLTX, MenuItemRBY(i), menu_item_strs[i]);
            EzSetColorByRGB(255, 255, 255);
            continue;
        }
        EzDrawStringB(MenuItemLTX, MenuItemRBY(i), menu_item_strs[i]);
    }
    EzDrawBoxB(MenuItemLTX-4, MenuItemLTY(cursor_pos)-2,
               MenuItemRBX+4, MenuItemRBY(cursor_pos)+2);
    EzShowBuffer();
}
